<?php

require_once("messages.class.php");
require_once("auth.class.php");

class frontend
{
    public $messages = null;

    public function __construct($path)
    {
        require("settings.php");
        
        //Check if we are in Maintainence Mode
        if ($setting_maintainence_mode === true)
        {
            print "Site Offline: " . $setting_maintainence_mode_message;
            exit();
        }
    
        $this->messages = new messages();
        $this->messages->construct_it();

        $restricted = array("ucp");
        $restricted_admin = array("acp");
        $exp = explode("/", $path);

        try
        {
            $logged_in = @$this->messages->auth->authcheck();
            $username = @$this->messages->auth->get_username();
            $admin = @$this->messages->auth->is_admin($username);  
        }
        catch (Exception $e)
        {
            $logged_in = False;
            $admin = False;
        }      

        foreach ($restricted as $r)
        {
            if (!($logged_in))
            {
                if ($exp[0] == $r)
                {
                    exit(); //TODO: Send them to a 403 page
                }
            }
        }

        foreach ($restricted_admin as $r)
        {
            if (!($admin))
            {
                if ($exp[0] == $r)
                {
                    exit(); //TODO: Send them to a 403 page
                }
            } 
        }
    }

    // Function for the <head> tag. $headextra is for any extra 
    // "on the spot" head tags (so you don't have to go back and edit
    // this function itself, just add some extra stuff when calling  head()
    function head($title='Ubuland: Unknown page',$headextra='')
    {
    	require("settings.php"); // for $setting_pwiki_url
    
        echo '
        <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
        <html xmlns="http://www.w3.org/1999/xhtml"><head>

        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
        <title>'.$title.'</title>
        <link rel="stylesheet" type="text/css" href="includes/stylesheet.css" />'.
        '<link rel="icon" type="image/png" href="images/favicon.ico"/>'.
        $headextra;
        
        //Piwik stats stuff - TEMPORARY URLS
        echo '<!-- Piwik -->

            <script type="text/javascript">
            var pkBaseURL = (("https:" == document.location.protocol) ? "'.$setting_piwik_url.'" : "'.$setting_piwik_url.'");
            document.write(unescape("%3Cscript src=\'" + pkBaseURL + "piwik.js\' type=\'text/javascript\'%3E%3C/script%3E"));
            </script>
            <script type="text/javascript">
            <!--
            piwik_action_name = "'.$title.'";
            piwik_idsite = 1;
            piwik_url = pkBaseURL + "piwik.php";
            piwik_log(piwik_action_name, piwik_idsite, piwik_url);
            //-->
            </script><object>
            <noscript><p>Free web analytics <img src="http://penguin/stats/piwik.php" style="border:0" alt="piwik"/></p>
            </noscript></object>
            <!-- /Piwik --> ';
       
        echo '</head>';
    }

    // Function for the navigation. the numbered navigation numbers
    // are for putting links before or after certain links that already
    // exist
    function nav($nav0='',$nav1='',$nav2='',$nav3='',$nav4='',$nav5='')
    {
        echo '
      <div id="header"><a href="index.php">
      <!--[if IE]><img src="images/logo.gif" alt="Ubuland Logo" /><![endif]-->'
	  // Display gif if IE (above) and display png if not (below) (see http://www.quirksmode.org/css/condcom.html)
	  // This is not nice - we should really check the user agent - or show a better gif to everyone
      .'<comment><img src="images/logo.png" alt="Ubuland Logo" /></comment>
      
      </a></div>
            <div id="themenu">
	    '.$nav0.'
	    <a href="?page=Home">Home</a>
	    '.$nav1.'
	    <a href="?page=About">About</a>
	    '.$nav2;
        if ($this->messages->auth->authcheck() === True) 
        {
            $username = $this->messages->auth->get_username();
            if ($this->messages->auth->is_admin($username))
            {
	        echo '<a href="?page=acp/Home">Admin Control Panel</a>
	        '.$nav5;
            }
	    echo '<a href="?page=ucp/Home">Control Panel</a>
	    '.$nav3;
        }
	    echo '<a href="?page=Contact">Contact Us</a>
	    '.$nav4;
        if ($this->messages->auth->authcheck() === False) 
        {
	    echo '<a href="?page=Register">Register</a>
	    '.$nav5;       
        }
        echo '<br style="clear: left;" /></div>';
    }

    function right_box(
    $admin_message='') 
    {
        if ($this->messages->auth->authcheck() === False)
        {
            echo '
        <div id="content_box">
          <div id="side_box">
            <div id="login_box">
	    	      <h3>Log In</h3>
                <form method="post" action="content/login_proc.php">
        	        <input name="username" type="text" /><br />
                  <input name="password" type="password" /><br />
                  <input class="submit" value="Log In" style="margin-top: 3px;" type="submit" />
                </form>
            </div>
          </div>';
        }
        else
        {
	    echo '
      <div id="content_box">
        <div id="side_box">';
            if (!($this->messages->auth->get_username() == False))
            {
                echo "<p>Logged in as: <b>".$this->messages->auth->get_username()."</b>.</p>";
            }
            echo '
		      <h3>Useful Links</h3>
		        <ul>
		        <li><a href="?page=ucp/Home">Control Panel</a></li>';
            if (!($this->messages->auth->get_username() == False))
            {
                echo "<li><a href=\"~".$this->messages->auth->get_username()."\">Your Website</a></li>";
            }

            $admin_message = $this->messages->show_messages();

            echo '
            <li><a href="content/logout_proc.php">Logout</a></li>
            </ul>
          <h3>Admin Messages</h3>
		        '.$admin_message.'
      </div>';
       }
    }

    function footer()
    {
		?>
        </div>
        <div id="footer">
        <p><!--[if IE]>You are using Intenet Explorer. Some parts of Ubuland may not display correctly on Internet Explorer. We strongly recommend you (for free) <a href="http://www.getfirefox.com" target="_blank">get Firefox.</a><![endif]--></p>
        </div>
        </div>
        </body>
        </html> <?php
    }

}
