<?php

require_once("db.class.php");
require_once("error.class.php");

class registration
{

    public $db = null;
    public $error = null;

    public function __construct()
    {
        $this->db = new db();
        $this->error = new errorhandler();
    }

    public function __destruct()
    {
        if ($this->db->isConnected === True)
        {
            $this->db->close();
        }
    }

    //Main function for registering users
    public function register($username, $ip, $email, $email_conf, $pass, $pass_conf)
    {
         $this->db->connect();


         //Error check users input
         if (empty($email))
         {
             $this->error->error("email_empty"); exit();
         }
         if (strtolower($email) !== strtolower($email_conf)) // Convert to lowercase first Bug #252230
         { 
             $this->error->error("email"); exit();
         }
         if (!($pass == $pass_conf))
         { 
             $this->error->error("password"); exit();
         }

         if (strlen($pass) < 6)
         {
             $this->error->error("password_len"); exit();
         }
         if (strlen($username) < 2)
         {
             $this->error->error("username_len"); exit();
         }

         //Clean things up before touching the database
         $username = $this->db->clean($username);
         $ip = $this->db->clean($ip); #You never know....
         $email = $this->db->clean($email);

         //Check if user exists already in the database
         $check = "SELECT * FROM `ubuland`.`users` WHERE `username` = '".$username."';";
         $result = $this->db->query($check);

         if (mysql_num_rows($result) != 0) 
         {
             $this->error->error("user_exists"); exit();
         }

         //If we get here then the users are sensible, set things up to be written into the database
         $pass = md5($pass);
         $act_code = md5(date("F j, Y, g:i a"));
         
         $query = "INSERT INTO `ubuland`.`users` (
`id` ,
`username` ,
`email` ,
`password` ,
`active` ,
`ip` ,
`actcode`,
`loginkey`
)
VALUES (NULL, '".$username."', '".$email."','".$pass."', 0,'".$ip."', '".$act_code."', 0);"; 

         if ($this->db->query($query) == 1) { return True; }
         else { return False; }
             
    }

    public function activate($code)
    {
        $this->db->connect();

        //Get user id for activation code
        $id = "SELECT * FROM `ubuland`.`users` WHERE `actcode` = '".$this->db->clean($code)."';";
        $result = $this->db->query($id);

        if (mysql_num_rows($result) < 1) 
        {
            $this->error->error("act_nouser"); exit();
            return False;
        }

        while($row = mysql_fetch_array($result))
        { 
            $uid = $row['id']; 
            $user = $row['username'];
        }

        $query = "UPDATE `ubuland`.`users` SET `active` = '1' WHERE `users`.`id` ='".$uid."' LIMIT 1 ;";
        $result = $this->db->query($query);
        
        // Piwik Account Creation
		require("piwik.class.php");
		$piwik = new piwik_wrapper();
		$result = $piwik->create_site($user);

		$result = strip_tags($result);
		
		if (!(is_numeric($result)))
		{
			$this->error->error("piwik_create_site"); exit();
		}
		else if ($result == false)
		{
			$this->error->error("should_not_happen"); exit();
		}

		header( 'Location: ../index.php?page=ConfirmDone&user='.$user );		    

    }
}
?>
